-- lightrays pixeleffect demo
-- löve2d 0.8.0
-- blog.ioxu.com

----------------------------- 
-- HSV > RGB color conversion
----------------------------- 
-- adapted from: 
-- http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript
-----------------------------

function HSVtoRGB(h, s, v, a)

  local r, g, b

  local i = math.floor(h * 6)
  local f = h * 6 - i
  local p = v * (1 - s)
  local q = v * (1 - f * s)
  local t = v * (1 - (1 - f) * s)

  local switch = i % 6
  if switch == 0 then
    r = v g = t b = p
  elseif switch == 1 then
    r = q g = v b = p
  elseif switch == 2 then
    r = p g = v b = t
  elseif switch == 3 then
    r = p g = q b = v
  elseif switch == 4 then
    r = t g = p b = v
  elseif switch == 5 then
    r = v g = p b = q
  end

  return r,g,b,a
  
end

function lerp(a,b,k)
	return (a + (b - a)*k)
end

function lerp3(a, b, k)
	--lerp 2 table3's by k
	return {lerp(a[1], b[1], k ),
			lerp(a[2], b[2], k ),
			lerp(a[3], b[3], k )}
end

-- util for converting image red channel to alpha channel
function rgbtoa_map( x, y, r, g, b, a )
	--return 255,255,255,255-r
	return 255,255,255,r
end

function file_rgbtoa(file)
	local id = love.image.newImageData(file)
	id:mapPixel( rgbtoa_map )
	return love.graphics.newImage(id)
end

-- convert 0-1 colour values to 0-255
function to255( r, g, b, a )
	return r*255, g*255, b*255, a*255
end
